From b327e6dc033c1469b65bc824db76025a0331b6f1 Mon Sep 17 00:00:00 2001
From: Ida Dittrich <i.dittrich@valueon.ch>
Date: Fri, 9 Jan 2026 10:49:06 +0100
Subject: [PATCH 4/5] fix: fixed webresearch, tweaked system prompt

---
 docs/WEBSEARCH_FIXES.md                       | 134 +++++++
 modules/aicore/aicorePluginTavily.py          | 251 +++++++++++--
 modules/features/chatbot/chatbotConstants.py  |  90 ++++-
 modules/features/chatbot/mainChatbot.py       | 224 +++++++++++-
 modules/services/serviceAi/mainServiceAi.py   |  31 +-
 modules/services/serviceWeb/mainServiceWeb.py | 331 ++++++++++++++++--
 6 files changed, 990 insertions(+), 71 deletions(-)
 create mode 100644 docs/WEBSEARCH_FIXES.md

diff --git a/modules/aicore/aicorePluginTavily.py b/modules/aicore/aicorePluginTavily.py
index 90718683..ffab7adc 100644
--- a/modules/aicore/aicorePluginTavily.py
+++ b/modules/aicore/aicorePluginTavily.py
@@ -321,13 +321,28 @@ class AiTavily(BaseConnectorAi):
         
         # Return all results without score filtering
         # Tavily's scoring is already applied by the API
-        logger.info(f"Tavily returned {len(response.get('results', []))} results")
+        results_count = len(response.get('results', []))
+        logger.info(f"Tavily returned {results_count} results")
+        
+        # Log content availability
+        results_with_content = 0
+        for result in response.get('results', []):
+            if result.get("raw_content"):
+                results_with_content += 1
+        logger.info(f"Tavily results with raw_content: {results_with_content}/{results_count}")
+        
+        # Log first result structure for debugging
+        if response.get('results') and len(response['results']) > 0:
+            first_result = response['results'][0]
+            logger.debug(f"First result keys: {list(first_result.keys())}")
+            raw_content = first_result.get('raw_content') or ''
+            logger.debug(f"First result has raw_content: {'raw_content' in first_result}, content length: {len(raw_content)}")
         
         return [
             WebSearchResult(
-                title=result["title"], 
-                url=self._cleanUrl(result["url"]),
-                rawContent=result.get("raw_content")
+                title=result.get("title", ""), 
+                url=self._cleanUrl(result.get("url", "")),
+                rawContent=result.get("raw_content") or result.get("content") or ""
             )
             for result in response["results"]
         ]
@@ -381,24 +396,90 @@ class AiTavily(BaseConnectorAi):
                 logger.debug(f"Tavily response received: {type(response)}")
                 
                 # Parse response - could be dict with results or list
-                if isinstance(response, dict) and "results" in response:
-                    pageResults = response["results"]
+                if isinstance(response, dict):
+                    if "results" in response:
+                        pageResults = response["results"]
+                        logger.debug(f"Found 'results' key in response dict with {len(pageResults)} items")
+                    else:
+                        logger.warning(f"Response dict keys: {list(response.keys())}")
+                        # Check for other possible keys
+                        if "pages" in response:
+                            pageResults = response["pages"]
+                            logger.debug(f"Found 'pages' key with {len(pageResults)} items")
+                        elif "content" in response:
+                            # Single page result
+                            pageResults = [response]
+                            logger.debug("Found 'content' key, treating as single page result")
+                        else:
+                            logger.warning(f"Unexpected response dict structure: {list(response.keys())}")
+                            pageResults = []
                 elif isinstance(response, list):
                     pageResults = response
+                    logger.debug(f"Response is a list with {len(pageResults)} items")
                 else:
-                    logger.warning(f"Unexpected response format: {type(response)}")
+                    logger.warning(f"Unexpected response format: {type(response)}, value: {str(response)[:200]}")
                     pageResults = []
                 
-                logger.debug(f"Got {len(pageResults)} pages from crawl")
+                logger.info(f"Got {len(pageResults)} pages from crawl for URL: {url}")
+                if len(pageResults) == 0:
+                    logger.warning(f"Tavily crawl returned 0 pages for URL: {url}. Response structure: {type(response)}")
+                    if isinstance(response, dict):
+                        logger.warning(f"Response keys: {list(response.keys())}")
+                        # Log all values to debug (not just first 3)
+                        for key, value in response.items():
+                            value_str = str(value)
+                            if len(value_str) > 200:
+                                value_str = value_str[:200] + "..."
+                            logger.warning(f"  {key}: {type(value)} - {value_str}")
+                        
+                        # Check for error messages in response
+                        if "error" in response:
+                            logger.error(f"Tavily API error in response: {response.get('error')}")
+                        if "message" in response:
+                            logger.warning(f"Tavily API message: {response.get('message')}")
+                    elif isinstance(response, str):
+                        logger.warning(f"Tavily returned string response (first 500 chars): {response[:500]}")
+                    else:
+                        logger.warning(f"Unexpected response type: {type(response)}, value: {str(response)[:500]}")
                 
-                # Convert to WebCrawlResult format
+                # Convert to WebCrawlResult format with error handling
                 results = []
-                for result in pageResults:
-                    results.append(WebCrawlResult(
-                        url=result.get("url", url),
-                        content=result.get("raw_content", result.get("content", "")),
-                        title=result.get("title", "")
-                    ))
+                for idx, result in enumerate(pageResults):
+                    try:
+                        # Safely extract fields
+                        result_url = result.get("url") if isinstance(result, dict) else (getattr(result, "url", None) if hasattr(result, "url") else url)
+                        result_content = ""
+                        if isinstance(result, dict):
+                            result_content = result.get("raw_content") or result.get("content") or ""
+                        elif hasattr(result, "raw_content"):
+                            result_content = result.raw_content or ""
+                        elif hasattr(result, "content"):
+                            result_content = result.content or ""
+                        
+                        result_title = ""
+                        if isinstance(result, dict):
+                            result_title = result.get("title", "")
+                        elif hasattr(result, "title"):
+                            result_title = result.title or ""
+                        
+                        results.append(WebCrawlResult(
+                            url=result_url or url,
+                            content=result_content,
+                            title=result_title
+                        ))
+                    except Exception as resultError:
+                        logger.warning(f"Error processing crawl result {idx}: {resultError}")
+                        # Try to create a minimal result with at least the URL
+                        try:
+                            if isinstance(result, dict) and result.get("url"):
+                                results.append(WebCrawlResult(
+                                    url=result.get("url", url),
+                                    content="",
+                                    title=""
+                                ))
+                        except Exception:
+                            logger.error(f"Failed to create minimal result for crawl result {idx}")
+                            continue
                 
                 logger.debug(f"Crawl successful: extracted {len(results)} pages from URL")
                 return results
@@ -413,7 +494,7 @@ class AiTavily(BaseConnectorAi):
                     
             except Exception as e:
                 logger.warning(f"Crawl attempt {attempt + 1} failed for URL {url}: {str(e)}")
-                logger.debug(f"Full error details: {type(e).__name__}: {str(e)}")
+                logger.debug(f"Full error details: {type(e).__name__}: {str(e)}", exc_info=True)
                 
                 # Check if it's a validation error and log more details
                 if "validation" in str(e).lower():
@@ -427,10 +508,22 @@ class AiTavily(BaseConnectorAi):
                     if len(url) > 2000:
                         logger.debug(f"    WARNING: URL is very long ({len(url)} chars)")
                 
+                # Log API-specific errors
+                error_str = str(e).lower()
+                if "rate limit" in error_str or "429" in error_str:
+                    logger.error(f"Tavily API rate limit hit for URL: {url}")
+                elif "401" in error_str or "unauthorized" in error_str:
+                    logger.error(f"Tavily API authentication failed for URL: {url}")
+                elif "404" in error_str or "not found" in error_str:
+                    logger.warning(f"URL not found (404) for: {url}")
+                elif "timeout" in error_str:
+                    logger.warning(f"Timeout error for URL: {url}")
+                
                 if attempt < maxRetries:
                     logger.info(f"Retrying in {retryDelay} seconds...")
                     await asyncio.sleep(retryDelay)
                 else:
+                    logger.error(f"Crawl failed after {maxRetries + 1} attempts for URL: {url}")
                     raise Exception(f"Crawl failed after {maxRetries + 1} attempts: {str(e)}")
     
     async def _routeWebOperation(self, modelCall: AiModelCall) -> "AiModelResponse":
@@ -508,21 +601,84 @@ class AiTavily(BaseConnectorAi):
                 includeRawContent="text"
             )
             
-            # Extract URLs from results
-            urls = [result.url for result in searchResults]
+            # Extract URLs and content from results with error handling
+            urls = []
+            results_with_content = []
+            content_count = 0
             
-            # Return as JSON array
+            try:
+                for result in searchResults:
+                    try:
+                        # Safely extract URL
+                        url = result.url if hasattr(result, 'url') and result.url else ""
+                        if url:
+                            urls.append(url)
+                        
+                        # Safely extract content
+                        content = ""
+                        if hasattr(result, 'rawContent'):
+                            content = result.rawContent or ""
+                        if not content and hasattr(result, 'content'):
+                            content = result.content or ""
+                        
+                        if content:
+                            content_count += 1
+                        
+                        # Safely extract title
+                        title = result.title if hasattr(result, 'title') and result.title else ""
+                        
+                        results_with_content.append({
+                            "url": url,
+                            "title": title,
+                            "content": content,
+                            "score": getattr(result, 'score', 0)
+                        })
+                    except Exception as resultError:
+                        logger.warning(f"Error processing individual search result: {resultError}")
+                        # Continue processing other results
+                        continue
+                
+                logger.info(f"Tavily search: {len(urls)} URLs, {content_count} with content, {len(results_with_content)} total results")
+                if content_count == 0:
+                    logger.warning("Tavily search returned no content - results may need crawling")
+            except Exception as extractionError:
+                logger.error(f"Error extracting URLs and content from search results: {extractionError}")
+                # Try to recover at least URLs
+                try:
+                    urls = [result.url for result in searchResults if hasattr(result, 'url') and result.url]
+                    logger.info(f"Recovered {len(urls)} URLs after extraction error")
+                except Exception:
+                    logger.error("Failed to recover any URLs from search results")
+            
+            # Return both URLs and full results in JSON for direct extraction
+            # Format: {"urls": [...], "results": [...]}
             import json
+            response_data = {
+                "urls": urls,
+                "results": results_with_content
+            }
+            
             return AiModelResponse(
-                content=json.dumps(urls, indent=2),
+                content=json.dumps(response_data, indent=2),
                 success=True,
-                metadata={"total_urls": len(urls), "operation": "WEB_SEARCH_DATA"}
+                metadata={
+                    "total_urls": len(urls),
+                    "operation": "WEB_SEARCH_DATA",
+                    "results_with_content": results_with_content  # Also in metadata for compatibility
+                }
             )
             
         except Exception as e:
-            logger.error(f"Error in Tavily web search: {str(e)}")
+            logger.error(f"Error in Tavily web search: {str(e)}", exc_info=True)
+            import json
+            # Return error response with empty results
+            error_response = {
+                "urls": [],
+                "results": [],
+                "error": str(e)
+            }
             return AiModelResponse(
-                content="[]",
+                content=json.dumps(error_response, indent=2),
                 success=False,
                 error=str(e)
             )
@@ -575,23 +731,44 @@ class AiTavily(BaseConnectorAi):
             # If we got multiple pages from the crawl, we need to format them differently
             # Return the first result for backwards compatibility, but include total page count
             if crawlResults and len(crawlResults) > 0:
-                # Get all pages content
+                # Get all pages content with error handling
                 allContent = ""
+                pageUrls = []
                 for i, result in enumerate(crawlResults, 1):
-                    pageHeader = f"\n{'='*60}\nPAGE {i}: {result.url}\n{'='*60}\n"
-                    if result.title:
-                        allContent += f"{pageHeader}Title: {result.title}\n\n"
-                    allContent += f"{result.content}\n"
+                    try:
+                        pageHeader = f"\n{'='*60}\nPAGE {i}: {result.url}\n{'='*60}\n"
+                        if result.title:
+                            allContent += f"{pageHeader}Title: {result.title}\n\n"
+                        else:
+                            allContent += f"{pageHeader}\n"
+                        allContent += f"{result.content or ''}\n"
+                        pageUrls.append(result.url)
+                    except Exception as pageError:
+                        logger.warning(f"Error formatting page {i} from crawl: {pageError}")
+                        # Try to add at least the URL
+                        try:
+                            pageUrls.append(result.url if hasattr(result, 'url') and result.url else webCrawlPrompt.url)
+                        except Exception:
+                            pass
                 
                 resultData = {
                     "url": webCrawlPrompt.url,
-                    "title": crawlResults[0].title if crawlResults[0].title else "Content",
+                    "title": crawlResults[0].title if crawlResults and crawlResults[0].title else "Content",
                     "content": allContent,
                     "pagesCrawled": len(crawlResults),
-                    "pageUrls": [result.url for result in crawlResults]
+                    "pageUrls": pageUrls
                 }
+                logger.info(f"Crawl successful: {len(crawlResults)} pages extracted from {webCrawlPrompt.url}")
             else:
-                resultData = {"url": webCrawlPrompt.url, "title": "", "content": "", "error": "No content extracted", "pagesCrawled": 0}
+                logger.warning(f"Crawl returned no results for URL: {webCrawlPrompt.url}")
+                resultData = {
+                    "url": webCrawlPrompt.url,
+                    "title": "",
+                    "content": "",
+                    "error": "No content extracted - Tavily crawl returned 0 pages",
+                    "pagesCrawled": 0,
+                    "pageUrls": []
+                }
             
             # Return as JSON - same format as Perplexity but with multiple pages content
             import json
@@ -602,9 +779,17 @@ class AiTavily(BaseConnectorAi):
             )
             
         except Exception as e:
-            logger.error(f"Error in Tavily web crawl: {str(e)}")
+            logger.error(f"Error in Tavily web crawl: {str(e)}", exc_info=True)
             import json
-            errorResult = {"error": str(e), "url": webCrawlPrompt.url if 'webCrawlPrompt' in locals() else ""}
+            crawl_url = webCrawlPrompt.url if 'webCrawlPrompt' in locals() else ""
+            errorResult = {
+                "url": crawl_url,
+                "title": "",
+                "content": "",
+                "error": str(e),
+                "pagesCrawled": 0,
+                "pageUrls": []
+            }
             return AiModelResponse(
                 content=json.dumps(errorResult, indent=2),
                 success=False,
diff --git a/modules/features/chatbot/chatbotConstants.py b/modules/features/chatbot/chatbotConstants.py
index 633528fa..7b3b6cec 100644
--- a/modules/features/chatbot/chatbotConstants.py
+++ b/modules/features/chatbot/chatbotConstants.py
@@ -158,12 +158,64 @@ WICHTIG: Wenn du Informationen aus der Datenbank präsentierst, kennzeichne dies
 - Beginne deine Antwort mit einer klaren Kennzeichnung, z.B.: "Aus der Datenbank habe ich folgende Artikel gefunden:"
 - Bei kombinierten Informationen (Datenbank + Internet): Trenne klar zwischen beiden Quellen
 
-QUELLENANGABE - INTERNET:
-WICHTIG: Wenn du Informationen aus dem Internet präsentierst, kennzeichne dies IMMER klar für den Nutzer.
-- Beginne Internet-Recherchen mit: "Aus meiner Internet-Recherche:" oder "Laut Online-Quellen:"
-- Gib IMMER die konkreten Quellen an (Website-Namen und Links)
-- Bei mehreren Quellen: Liste die Quellen auf und verweise darauf
-- Trenne klar zwischen Datenbank-Informationen und Internet-Recherchen
+⚠️⚠️⚠️ QUELLENANGABE - INTERNET - ABSOLUT VERBINDLICH ⚠️⚠️⚠️
+Wenn du Informationen aus einer Web-Recherche präsentierst, MUSS du dies IMMER explizit kennzeichnen und die Quellen angeben:
+- ❌ VERBOTEN: Informationen aus Web-Recherchen ohne explizite Kennzeichnung zu präsentieren
+- ❌ VERBOTEN: Informationen aus Web-Recherchen ohne Quellenangabe zu präsentieren
+- ❌ VERBOTEN: Quellen nur am Ende als Liste zu präsentieren
+- ✓ OBLIGATORISCH: Beginne IMMER mit einer expliziten Kennzeichnung, z.B.:
+  * "Aus meiner Web-Recherche habe ich folgende Informationen gefunden:"
+  * "Laut meiner Internet-Recherche:"
+  * "Aus meiner Online-Suche:"
+- ✓ OBLIGATORISCH: Gib IMMER die konkreten Quellen DIREKT NACH der jeweiligen Information an (nicht am Ende!)
+- ✓ OBLIGATORISCH: Format: [Information] ([Quelle: Website-Name](URL))
+- ✓ OBLIGATORISCH: Bei mehreren Informationen: Gib nach JEDER Information die entsprechende Quelle an
+- ✓ OBLIGATORISCH: Trenne klar zwischen Datenbank-Informationen und Web-Recherchen
+- ✓ OBLIGATORISCH: Wenn sowohl Datenbank- als auch Web-Informationen vorhanden sind, trenne diese klar in separaten Abschnitten
+
+⚠️⚠️⚠️ DATENBLATT-LINKS - ABSOLUT VERBINDLICH ⚠️⚠️⚠️
+Wenn Web-Recherche-Ergebnisse vorhanden sind, MUSS du IMMER:
+- ✓ OBLIGATORISCH: Explizit erwähnen, dass Datenblätter verfügbar sind
+- ✓ OBLIGATORISCH: ALLE verfügbaren Datenblatt-Links angeben (vollständige URLs)
+- ✓ OBLIGATORISCH: Format: "Datenblätter verfügbar: [Link 1](URL1), [Link 2](URL2)"
+- ✓ OBLIGATORISCH: Wenn keine direkten Datenblatt-Links vorhanden sind, gib Links zu Seiten mit technischen Informationen an
+- ❌ VERBOTEN: Datenblatt-Links zu verschweigen oder nicht explizit zu erwähnen
+
+⚠️⚠️⚠️ AUSFÜHRLICHE INFORMATIONEN - ABSOLUT VERBINDLICH ⚠️⚠️⚠️
+Wenn Web-Recherche-Ergebnisse vorhanden sind, MUSS du:
+- ✓ OBLIGATORISCH: AUSFÜHRLICHE Informationen präsentieren (nicht nur kurze Zusammenfassungen!)
+- ✓ OBLIGATORISCH: Alle relevanten technischen Details angeben:
+  * Technische Spezifikationen (Größe, Gewicht, Abmessungen, etc.)
+  * Betriebsbedingungen (Temperatur, Spannung, etc.)
+  * Kompatibilität und Anwendungsbereiche
+  * Zertifizierungen und Normen
+  * Installation und Verwendung
+  * Weitere relevante Produktdetails
+- ✓ OBLIGATORISCH: Strukturiere die Informationen übersichtlich (z.B. mit Abschnitten oder Aufzählungen)
+- ❌ VERBOTEN: Nur oberflächliche Informationen zu geben
+- ❌ VERBOTEN: Wichtige Details auszulassen
+
+BEISPIEL FÜR KORREKTE QUELLENANGABE MIT INLINE-QUELLEN:
+"Aus meiner Web-Recherche habe ich folgende Informationen gefunden:
+
+**Technische Spezifikationen:**
+- Speicherkapazität: 2 GB ([Quelle: Siemens Support](https://...))
+- Format: Secure Digital (SD) Card ([Quelle: Best4Automation](https://...))
+- Betriebsspannung: 3,3 V DC ([Quelle: Automation24](https://...))
+
+**Kompatibilität:**
+- Geeignet für SIMATIC HMI Comfort Panels ([Quelle: Siemens Support](https://...))
+- Montage im Hoch- und Querformat möglich ([Quelle: Best4Automation](https://...))
+
+**Zertifizierungen:**
+- CE-zertifiziert ([Quelle: Automation24](https://...))
+- Für ATEX-Zonen geeignet ([Quelle: Elit](https://...))
+
+**Datenblätter verfügbar:**
+- [Siemens Produktdatenblatt](https://...)
+- [Technische Dokumentation](https://...)"
+
+NIEMALS Informationen aus Web-Recherchen präsentieren, ohne explizit zu erwähnen, dass es sich um eine Web-Recherche handelt und ohne die Quellen DIREKT NACH der jeweiligen Information anzugeben!
 
 TABELLENLÄNGE UND ARTIKELANZAHL - KRITISCH:
 WICHTIG: Zeige MAXIMAL 20 Artikel in Tabellen. Du darfst und sollst aber ausführliche Erklärungen liefern!
@@ -316,6 +368,17 @@ Analysiere die Benutzeranfrage und bestimme:
    - Jede Abfrage sollte fokussiert sein und die benötigten Informationen aus einer spezifischen Tabelle/Datenquelle abrufen
 4. Begründung für deine Entscheidung
 
+⚠️⚠️⚠️ WICHTIG - WEB-RECHERCHE BEI ZUSÄTZLICHEN INFORMATIONEN ⚠️⚠️⚠️
+Wenn der Nutzer nach zusätzlichen Informationen fragt oder explizit eine Recherche anfordert, MUSS IMMER eine Web-Recherche durchgeführt werden (needsWebResearch = true).
+Beispiele für solche Anfragen:
+- "recherchier nach weiteren informationen zu diesem produkt"
+- "suche nach zusätzlichen informationen"
+- "finde mehr details"
+- "recherchiere im internet"
+- "suche online nach"
+- Ähnliche Formulierungen, die eine Recherche oder zusätzliche Informationen anfordern
+In diesen Fällen IMMER needsWebResearch auf true setzen!
+
 WICHTIG für SQL-Abfragen:
 - Verwende IMMER doppelte Anführungszeichen für Spaltennamen
 - Bei Lagerbestandsabfragen: IMMER S_RESERVIERTER__BESTAND und verfügbaren Bestand einbeziehen
@@ -550,6 +613,21 @@ Antworte auf die folgende Frage des Nutzers: {user_prompt}{context}
 
 KRITISCH: Verwende NUR die oben angegebenen Daten. Erfinde KEINE Werte. Wenn Daten fehlen, schreibe "Nicht verfügbar".
 
+⚠️⚠️⚠️ ABSOLUT KRITISCH - WEB-RECHERCHE QUELLENANGABE ⚠️⚠️⚠️
+Wenn WEB-RECHERCHE-ERGEBNISSE oben vorhanden sind, MUSS du:
+- ✓ IMMER explizit erwähnen, dass die Informationen aus einer Web-Recherche stammen
+- ✓ IMMER alle Quellen DIREKT NACH der jeweiligen Information angeben (INLINE, nicht am Ende!)
+- ✓ Format: [Information] ([Quelle: Website-Name](URL))
+- ✓ IMMER AUSFÜHRLICHE Informationen präsentieren (nicht nur kurze Zusammenfassungen!)
+- ✓ IMMER alle verfügbaren Datenblatt-Links explizit erwähnen und angeben
+- ✓ Format für Datenblätter: "Datenblätter verfügbar: [Link 1](URL1), [Link 2](URL2)"
+- ✓ Die Web-Recherche-Informationen klar von Datenbank-Informationen trennen
+- ❌ VERBOTEN: Web-Recherche-Informationen ohne explizite Kennzeichnung zu präsentieren
+- ❌ VERBOTEN: Web-Recherche-Informationen ohne Quellenangabe zu präsentieren
+- ❌ VERBOTEN: Quellen nur am Ende als Liste zu präsentieren
+- ❌ VERBOTEN: Datenblatt-Links zu verschweigen oder nicht explizit zu erwähnen
+- ❌ VERBOTEN: Nur oberflächliche Informationen zu geben
+
 ⚠️⚠️⚠️ ABSOLUT VERBOTEN - KEINE DATEN ERFINDEN ⚠️⚠️⚠️
 Wenn KEINE Datenbank-Ergebnisse vorhanden sind (keine DATENBANK-ERGEBNISSE oder STRUKTURIERTE DATEN oben), dann:
 - ❌ ERFINDE KEINE Artikelnummern, Artikelbezeichnungen, Preise oder Lagerbestände!
